//+------------------------------------------------------------------+
//|                                                  TwitterDemo.mq5 |
//|                                            Copyright 2020, seffx |
//|                              https://www.mql5.com/en/users/seffx |
//+------------------------------------------------------------------+
//Published on MQL5 for Public Domain Usage
#property copyright "Copyright 2020, seffx"
#property link      "https://www.mql5.com/en/users/seffx"
#property version   "1.00"
#property strict

#include <Twitter.mqh>

sinput string consumer_key = "JRbS2bqDvbR7N0x9qIg1neXr1";
sinput string consumer_secret = "mbJMSszwJIUnOGtmNfjfpDhI3AnKSz9RKvOfonDwfpNq7Fffso";
sinput string access_token = "1286617533441667072-lBPuJTwtIH41iQY10ltjpXrC6aXoe1";
sinput string access_secret = "MoiH6MG7pXBHgzlvUeskQEYMwO1jPEmP1He2UbS703HH0";
sinput bool uploadScreenshots = true; // Upload screenshots
sinput bool verbose = false; // Debug


#define        WIDTH  800     // Image width to call ChartScreenShot() 
#define        HEIGHT 600     // Image height to call ChartScreenShot() 

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string periodName(ENUM_TIMEFRAMES tf)
  {
   switch(tf)
     {
      case PERIOD_MN1:
         return("MN");
      case PERIOD_W1:
         return("W1");
      case PERIOD_D1:
         return("D1");
      case PERIOD_H4:
         return("H4");
      case PERIOD_H1:
         return("H1");
      case PERIOD_M30:
         return("M30");
      case PERIOD_M15:
         return("M15");
      case PERIOD_M5:
         return("M5");
      case PERIOD_M1:
         return("M1");
     }
   return EnumToString(tf);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Screenshots(string &filenames[], string &msg)
  {
   long chartId=ChartFirst();
   int i=0;
   // Twitter allow max. 4 photos in a tweet
   int limit=4;  
   string fname = "";
   ArrayResize(filenames, limit);
   msg = "";
   MqlRates rates[];
   while(i<limit)
     {
      if(chartId<0)
         break; // end of the chart list

      string sym = ChartSymbol(chartId);
      ENUM_TIMEFRAMES tf = ChartPeriod(chartId);

      int copied=CopyRates(sym,tf,0,1,rates);
      if(copied == 1)
        {
         msg = StringFormat("%s,%s %.5f/%.5f/"
                            "%.5f/%.5f/%.2f %s %s\r\n%s",
                            sym, periodName(tf),
                            rates[0].open,
                            rates[0].high,
                            rates[0].low,
                            rates[0].close,
                            rates[0].real_volume,
                            StringSubstr(TimeToString(rates[0].time,
                                         TIME_DATE),5),
                            TimeToString(rates[0].time,
                                         TIME_MINUTES),
                            msg
                           );
        }
      fname = StringFormat("%s_%d.png", sym, tf);;
      //Print(i, ": ", fname, " ID =",chartId);
      filenames[i] = fname;
      if(!ChartScreenShot(chartId, fname, WIDTH,HEIGHT))
        {
         if(verbose)
            Print("* error: ", fname, " failed");
        }
      chartId=ChartNext(chartId);
      i++;// increase the counter
     }
  }

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   string fnames[4];
   string medias;
   string msg;
   
   CTwitter tw(consumer_key, consumer_secret,
               access_token, access_secret, verbose);


   string resp = tw.verifyCredentials();
   //Print(resp);
   
   Print("ID         : ", tw.getTokenValue(resp, "id"));
   Print("Name       : ", tw.unquote(tw.getTokenValue(resp, "name")));
   Print("Screen_name: ", tw.unquote(tw.getTokenValue(resp, "screen_name")));
               
   // Gather information
   Screenshots(fnames, msg);

   if (uploadScreenshots)
   {   
      // Upload screenshots
      int n = ArraySize(fnames);
      int i = n - 1;
      // create comma separated media_ids
      medias = tw.uploadPhoto(fnames[i]);
      for(i= n - 2; i>=0; i--)
      {
         StringAdd(medias, ",");
         StringAdd(medias, tw.uploadPhoto(fnames[i]));
      }
   }
   
   // Send Tweet with photos' ids
   resp = tw.tweet(msg, medias);
   Print(resp);
  }
//+------------------------------------------------------------------+
